


#define _DynamicDataBuffer_

// C++
#include<fstream>
#include<iostream>
#include<fstream>
#include<iostream>
#include<string>
#include<vector>
#include<sstream>
 #include <algorithm>//sort function
// C

// local
#include "DynamicDataBuffer.h"
//#include "sadxml.h"

#define SWAP_2(x) ( (((x) & 0xff) << 8) | ((unsigned short)(x) >> 8) )
#define SWAP_4(x) ( ((x) << 24) | \
         (((x) << 8) & 0x00ff0000) | \
         (((x) >> 8) & 0x0000ff00) | \
         ((x) >> 24) )


class FeatWarper {
 public:
    FeatWarper(long w){  warpWin=w;  }
    ~FeatWarper(){}; 
		
		void getWarpedVector(long index,float* vout);
		void setInput(FeatureBuffer* featInput){  
				fin=featInput; 
				nFeatures= fin->getVecDimen();
				if(fout.getVecDimen() != nFeatures ) fout.resetVecDimen(nFeatures) ;
		 }
		void doWarping(string fwfile);
 private:

		void runFeatWarper();
		void warpVector(float** vOfV,int nVecs,long index);
		float warpFeature(float* vec,int idx,int thisWin);
		FeatureBuffer* fin;
		FeatureBuffer	fout;
		vector<float> wfTable;
		int nFeatures ;
		long warpWin;
    
};


void
FeatWarper::doWarping(string fwfile)
{
	string finput;
	ifstream input(fwfile.c_str());
	if(!input){  cout << "FeatWarper::readFWLookUpTable ERROR::cannot open input file " << fwfile.c_str() << endl; exit(0); }
	
	int count=0;
	while (input >> finput) {
		if( (count % 2)==1){
			wfTable.push_back(atof(finput.c_str()));
		}
		count++;
	}
	//comprovar N?
	if(wfTable.size()!=warpWin){
		 cout << "FeatWarper::readFWLookUpTable ERROR::Number of lines readed " << wfTable.size() << " doesn't match with warpWin=" << warpWin << endl; exit(0); }
	
	runFeatWarper();
}


void
FeatWarper::getWarpedVector(long index,float* vout){ 

	//cout << "size " << fout.length() << "/" << "index" << index << endl;
	float* tmp=fout.vec(index);
	for(int i=0;i<nFeatures;i++){
		
		vout[i]=tmp[i];
	}
}

//Too much time consuming do it for just one index
//process all buffer
void
FeatWarper::runFeatWarper()
{
	//read warped matrix
	//se suposa que el fitxer tindra mes de 1,5segons!!
	

	//cout << "FeatureWarping" << endl;
	//cout << "finsize " << fin->length()  << endl;
	//suposa minim de 3 segons!!
	//comprovar que el fitxer es mes gran que 3 segons!!
	//midwin es per la finestra imparell!!
	int midWarpWin=(warpWin-1)>>1;
	long endIdx;
	long maxInput=fin->length();
	
	float** vOfV;	//matrix of values
	vOfV=new float* [nFeatures];
	vOfV[0]=new float[nFeatures*warpWin];
	for(int i=1; i< nFeatures;i++){
		vOfV[i] = vOfV[i-1] + warpWin ;
	}
	float* v; //for reading vectors from buffer
	

	//--------- NON-full windows------------
	//first non-full window
	if( maxInput <= midWarpWin){//if file is smaller thant midWarpWin
		for(long i=0; i< maxInput ; i++)
		{
			v=fin->vec(i);
			for(int j=0; j< nFeatures ; j++){ vOfV[j][i]=v[j]; }
			
		}
		endIdx=maxInput;
	}else{
		for(long i=0; i< midWarpWin ; i++)
		{
			v=fin->vec(i);
			for(int j=0; j< nFeatures ; j++){ vOfV[j][i]=v[j]; }
					/*if(i==112){
					for(int i=0;i<nFeatures;i++){
						cout << v[i] << " " ;
					
					}
					cout << " " << endl;
					}	*/
		}
		endIdx=midWarpWin;
	}
	
	
	bool end=false;	
	//cout << "midwarpwin " << midWarpWin << endl;
	//the rest of non-full windows
	if( maxInput <= midWarpWin){//if file is smaller thant midWarpWin we cannot read any new frame and we just want to warp each of the frames previously read
		for(long i=0 ; i< maxInput ; i++)
		{
			warpVector(vOfV,endIdx,i);
		}
		end=true;
	}else{//in the rest of cases, there still are frames to read
		for(long i=0 ; i< midWarpWin ; i++)
		{
			//cout << i << endl;
			//	if(i==(maxInput-midWarpWin-1)){ goto FINISH; }   //if files is smaller than warpWin  ja no podem afegir res mes!
		
			if(endIdx<maxInput){//just to control that we can keep reading from fin
				
				v=fin->vec(endIdx);
				
				for(int j=0; j< nFeatures ;j++){	vOfV[j][endIdx]=v[j]; }
				endIdx++;
				
			}else{
				end=true;
			}
			//cout << i << endl;
			//if(i<maxInput)
				warpVector(vOfV,endIdx,i);
			
		}
	}
	
	if(end) goto FINISH;
	if(fin->length() - midWarpWin<=midWarpWin) goto LASTSTEP;
	//cout << "hola" << endl;

	long	circIndex = endIdx % warpWin;
	long refindex = midWarpWin % warpWin;
	//cout << midWarpWin << endl;
//	cout <<    << endl;
	
	//--------- Full windows------------
	for(long i= midWarpWin ; i< ( fin->length() - midWarpWin  ) ; i++) {
		//cout << endIdx << endl;cout.flush();
		//cout << i << endl;
		v=fin->vec(endIdx);
		for(int j=0; j< nFeatures ;j++){	vOfV[j][circIndex]=v[j]; }
		warpVector(vOfV,warpWin,refindex);
		circIndex= (circIndex+1) % warpWin;
		refindex = (refindex+1) % warpWin;
		endIdx++ ;
		//cout << "end" <<  i <<" "<< fin->length() - midWarpWin << endl;
		//getWarpedFeature() tenint en compte que potser que tinguem menys Ns
	}
	
	
	//cout << "hola " << endl;
	LASTSTEP:
	//---------NON-full windows at the end----
	float** vOfVr;

		endIdx=warpWin-1;
		vOfVr = new float* [nFeatures];
		vOfVr[0]=new float[nFeatures*endIdx];
		for(long i=1; i< nFeatures;i++){
			vOfVr[i] = vOfVr[i-1] + endIdx ;
		}
		
		refindex= midWarpWin-1; 
	

	//circIndex points to the new position. Plus one, we get the older data in buffer
	for(long i= endIdx-1  ; i >= 0 ;i--)
	{
		circIndex=(circIndex+1) % warpWin;
		for(int j=0; j< nFeatures ;j++){ vOfVr[j][i]=vOfV[j][circIndex]; }
	}
	
	
	

	for(long i=(fin->length() - midWarpWin) ; i< fin->length() ; i++) {
		//getWarpedFeaure
		warpVector(vOfVr,endIdx,refindex);
		endIdx--;
		refindex--;
	}

	delete [] vOfVr[0];
	delete [] vOfVr;
	
	FINISH:

	delete [] vOfV[0];
	delete [] vOfV;

	
	

	/*

	for(long i= midWin ; i<(aedDecWin.getCirQSize() - midWin  ) ; i++) {
		circVotingWin[circIndex]=aedDecWin.value(endVoteIdx);
		//moreFrequentOf(circVotingWin,votingWin,&afterVoting[i],&max2,&votingConf[i],&conf2);

		moreFrequentOf(circVotingWin,votingWin,&max1,&max2,&votingConf[i],&conf2);
		if(votingConf[i]==conf2) afterVoting[i]=circVotingWin[ i % votingWin];	//value flag do not change
		else afterVoting[i]=max1;
		circIndex= (circIndex+1) % votingWin;
		endVoteIdx++ ;
	}
	//at the end of buffer, not-full-windows again
	//first, copy last part of buffer
	int* restVotingWin;
	endVoteIdx=votingWin-1;
	restVotingWin = new int [endVoteIdx];

	//circIndex points to the new position. Plus one, we get the older data in buffer
	for(int i= endVoteIdx-1  ; i >= 0 ;i--)
	{
		circIndex=(circIndex+1) % votingWin;
		restVotingWin[i]=circVotingWin[circIndex];
	}
	for(long i=(aedDecWin.getCirQSize() - ((votingWin -1 )>> 1)) ; i<aedDecWin.getCirQSize() ; i++) {
		moreFrequentOf(restVotingWin,endVoteIdx,&max1,&max2,&votingConf[i],&conf2);
		if(votingConf[i]==conf2){ afterVoting[i]=circVotingWin[ i % votingWin];	}//value flag do not change
		else afterVoting[i]=max1;
		endVoteIdx--;
	}





*/




}


float
FeatWarper::warpFeature(float* vec,int idx,int thisWin)
{
	//cout << "ref " << vec[idx] << endl;
	double featToWarp=vec[idx];
	//if(idx==112){
	//cout << "ref " << vec[idx] << endl;
	
	//}
	
	//copy vector
	vector<float> tmp_vec;
	for(int i=0;i<thisWin;i++)
	{
		tmp_vec.push_back(vec[i]);
	}
	sort(tmp_vec.begin(),tmp_vec.end());
	//find rank of feature
	int x= find (tmp_vec.begin(),tmp_vec.end(), featToWarp )- tmp_vec.begin() ;
	if(thisWin<warpWin){//scale range
		x*=warpWin/thisWin;
	}
	
	float y=wfTable[x];
	//cout << "x=" << x << " " << "y=" << y << endl;
	return y;
}



//index  index de la trama on escriurem el vector
void
FeatWarper::warpVector(float** vOfV,int nVecs,long index)
{
	//cout << "vecs " << nVecs << "index "<< index  <<  endl;
	float v[nFeatures];
	for(int i=0;i< nFeatures; i++)
	{
		/*cout << "Before Warp (nVecs="<< nVecs << "/idx=" << index << ")" << endl;
		for(int j=0; j< nVecs;j++)
		{
				cout << vOfV[i][j] << " " ;
		}
		cout << " " << endl;
	*/
		
	
		v[i]=	warpFeature(vOfV[i],index,nVecs);//index es la variable que es interessa trobar un cop el vector es ordenat
	}
	fout.appendVec(v);
}



// --- FeatureBuffer start ---
//Creates the delta and acceleration filters of the desired size.
//! \param halfDeltaSpan half size of the delta filter; total filter size = 2 * halfDeltaSpan + 1
//! \param halfAccelSpan half size of the second delta filter applied on the top of the first one. Thus, the total filter size will be = 2 * halfDeltaSpan + 2* halfAaccelSpan + 1
template <> void
FeatureBuffer::creaHtkDelAccFilter(short halfDeltaSpan, short halfAccelSpan)
{
    int i ;
    short deltaLength, accelLength, tmpAccLength;
    
    // delta filter
    halfDelSpan = halfDeltaSpan ;				//half the lenght of the delta filter
    deltaLength = 2*halfDelSpan + 1 ;			//whole lenght of the delta filter
    htkDelFilter = new float [deltaLength] ;	//allocate memory for the filter values
    float normFactor = 0;					
    for(i=1 ; i<=halfDelSpan ; i++)				//normalization factor calculation
		normFactor += i * i ;
    normFactor = (float)1 / (2*normFactor) ; //2*normFactor= squared sum of all filter values
    for(i=-halfDelSpan ; i<=halfDelSpan ; i++)
	 	htkDelFilter[i + halfDelSpan] = i * normFactor ;//delta filter coeficients (from left to right). the center value is zero

    // acceleration filter
    halfAccSpan = halfAccelSpan ;				
    tmpAccLength = 2*halfAccSpan + 1 ;			
    float* tmpAccFilter = new float [tmpAccLength] ;	
    accelLength = deltaLength + tmpAccLength - 1 ;		//total acceleration length
    htkAccFilter = new float [accelLength] ;			
    normFactor = 0;
    for(i=1 ; i<=halfAccSpan ; i++)				//normalization factor calculation
		normFactor += i * i ;
    normFactor = (float)1 / (2*normFactor) ;
    for(i=-halfAccSpan ; i<=halfAccSpan ; i++)
		tmpAccFilter[i + halfAccSpan] = i * normFactor ;	//temp delta filter coeficients 
    //acceleration filter coeficients are obtained from the convolution of the temp delta filter with the first delta filter
    for(i=0 ; i<accelLength ; i++) {		
		htkAccFilter[i] = 0 ;
		int jMax = i ;
		if(i > (tmpAccLength-1))     //i>2
	    	jMax = (tmpAccLength - 1) ; //jMax=2
		int jMin = 0 ;
		if((i - jMin) > (deltaLength-1)) //i>4
	   	 jMin = i - (deltaLength-1) ; //jMin=i-4
		for(int j=jMin ; j<=jMax ; j++)
	    	htkAccFilter[i] += tmpAccFilter[j] * htkDelFilter[i - j] ;
    }
    delete [] tmpAccFilter ;	//delete temp delta coeficients
}


template <> void
FeatureBuffer::creaSCFilter(short halfDeltaSpan)
{
    int i ;
    short deltaLength, accelLength, tmpAccLength;
    
    // delta filter
    halfDelSpan = halfDeltaSpan ;				//half the lenght of the delta filter
    deltaLength = 2*halfDelSpan + 1 ;			//whole lenght of the delta filter
    htkDelFilter = new float [deltaLength] ;	//allocate memory for the filter values
    float normFactor = 0;					
    for(i=1 ; i<=halfDelSpan ; i++)			//normalization factor calculation
			normFactor += i * i ;
    normFactor = (float)1 / (2*normFactor) ; //2*normFactor= squared sum of all filter values
		normFactor = 1;
    for(i=-halfDelSpan ; i<=halfDelSpan ; i++)
	 		htkDelFilter[i + halfDelSpan] = i * normFactor ;//delta filter coeficients (from left to right). the center value is zero
		
		
		
}		

//Filters the vector values of the requested index 
//! Filter is assumed to be of impar length and it does not have to be symetric
//! e.g. filter of length 5 is {filCoef[0],filCoef[1],filCoef[2],filCoef[3],filCoef[4]}
//! halfFilLength=2 and the current sample is filCoef[2]
//! \param index index of the requested vector
//! \param filOut pointer where to allocate the filter output
//! \param filCoef pointer to the filter coeficients
//! \param halfFilLenght half the length-1 of the vector
template <> void
FeatureBuffer::timeFirFilter(long index, float* filOut, float* filCoef, short halfFilLength)
{
    long idxPost, idxPrio, idx=index ;
    float* h; // filter impulse response
    int i, j;
    
    if(isCirQ()) idx &= (cirQSize-1) ;	//modulus indexation needed if is circular

    h = & filCoef[halfFilLength] ;	//value of the central filter coeficient (zero, generally)
    for(i=0 ; i<vecDimen ; i++) 		//init vector
		filOut[i] = (*h) * ((*this)[idx*vecDimen + i]) ;

	//idxPrio= index to the past values 
	//idxPost= index to the future values
	//Note than using idxPrio and idxPost alows to filter in halfFilLength iterations
    for(j=1 ; j<=halfFilLength ; j++) {
		
		idxPrio = index - j ;
		if(idxPrio<0) idxPrio=0 ;	//for the first times
		if(isCirQ()) idxPrio &= (cirQSize-1) ;//modulus indexation needed if is circula
		idxPrio *= vecDimen ;		//if vecDimen>1
	
		idxPost = index + j ;
		if(idxPost >= (last-1)) idxPost = last-1 ; //for the first times
		if(isCirQ()) idxPost &= (cirQSize-1) ;	//modulus indexation needed if is circular
		idxPost *= vecDimen ; 	//if vecDimen>1

		for(i=0 ; i< vecDimen ; i++)    // convolution
		{ 	//   printf("%f:%f+%f:%f ",*(h-j),(*this)[idxPost + i] ,*(h+j), (*this)[idxPrio + i]);
			//	  printf("%f %f+%f %f/ ",*(h-j),(*this)[idxPost + i] ,*(h+j),(*this)[idxPrio + i] );
			filOut[i] += (*(h-j)) * ((*this)[idxPost + i]) + (*(h+j)) * ((*this)[idxPrio + i]) ;
      }
		//	printf("\n");
    }
}


template <> void
FeatureBuffer::SCFilter(long index, float* filOut, float* filCoef, short halfFilLength)
{
    long idxPost, idxPrio, idx=index ;
    float* h; // filter impulse response
    int i, j;
    
    if(isCirQ()) idx &= (cirQSize-1) ;	//modulus indexation needed if is circular
    h = & filCoef[halfFilLength] ;	//value of the central filter coeficient (zero, generally)
    for(i=0 ; i<12 ; i++) {		//init vector
		//std::cout << " " << (*this)[idx*vecDimen + i] ;
		filOut[i] = (*h) * ((*this)[idx*vecDimen + i]) ;
		}
		//std::cout << ";\n"  ;
	//idxPrio= index to the past values 
	//idxPost= index to the future values
	//Note than using idxPrio and idxPost alows to filter in halfFilLength iterations
    for(j=1 ; j<=halfFilLength ; j++) {
		
		idxPrio = index - j ;
		if(idxPrio<0) idxPrio=0 ;	//for the first times
		if(isCirQ()) idxPrio &= (cirQSize-1) ;//modulus indexation needed if is circula
		idxPrio *= vecDimen ;		//if vecDimen>1
	
		idxPost = index + j ;
		if(idxPost >= (last-1)) idxPost = last-1 ; //for the first times
		if(isCirQ()) idxPost &= (cirQSize-1) ;	//modulus indexation needed if is circular
		idxPost *= vecDimen ; 	//if vecDimen>1

		for(i=0 ; i< 12 ; i++)    // convolution
		{ 	//   printf("%f:%f+%f:%f ",*(h-j),(*this)[idxPost + i] ,*(h+j), (*this)[idxPrio + i]);
			//	  printf("%f %f+%f %f/ ",*(h-j),(*this)[idxPost + i] ,*(h+j),(*this)[idxPrio + i] );
			filOut[i] += (*(h-j)) * ((*this)[idxPost + i]) + (*(h+j)) * ((*this)[idxPrio + i]) ;
      }
		//	printf("\n");
    }

}


//D1K7P3

template <> void
FeatureBuffer::ShiftDeltaFilter(long index,float* filOut,int P, int D, int K)
{
	//Shift Delta Coefficents parameters:  N,D,P,K
	//AC_0(0) AC_1(0) ... AC_N-1(0), AC_0(1) AC_1(1) ... AC_N-1(1), ... , AC_0(K-1) AC_1(K-1) ... AC_N-1(K-1)
	
    long idxPost, idxPrio, idx=index ;
    int i;
    int k;
    if(isCirQ()) idx &= (cirQSize-1) ;	//modulus indexation needed if is circular
    //for(i=0 ; i< vecDimen*K ; i++) {	//init vector has k*vecDimen features
	//	filOut[i] = 0  ;
	//}
		
	//idxPrio= index to the past values 
	//idxPost= index to the future values
	//Note than using idxPrio and idxPost alows to filter in halfFilLength iterations
	for(k=0; k < K ; k++){
		
		idxPrio = index - D + k*P ;
		if(idxPrio<0) idxPrio=0 ;//for the first times 
		if(isCirQ()) idxPrio &= (cirQSize-1) ;//modulus indexation needed if is circular
		idxPrio *= vecDimen ; //if vecDimen>1
	
		idxPost = index + D + k*P ;
		if(idxPost >= (last-1)) idxPost = last-1 ; //for the first times
		if(isCirQ()) idxPost &= (cirQSize-1) ;	//modulus indexation needed if is circular
		idxPost *= vecDimen ; 	//if vecDimen>1

		for(i=0 ; i< vecDimen ; i++)    // convolution
		{ 	//   printf("%f:%f+%f:%f ",*(h-j),(*this)[idxPost + i] ,*(h+j), (*this)[idxPrio + i]);
			//	  printf("%f %f+%f %f/ ",*(h-j),(*this)[idxPost + i] ,*(h+j),(*this)[idxPrio + i] );
			filOut[k*vecDimen+i] = ((*this)[idxPost + i]) - ((*this)[idxPrio + i]) ;
		}
		//	printf("\n");
    	
	}
}


//------------------------ STATIC + DELTA + ACCELERATION -------------------------------//
// 
//Calculates and provides static + delta + acceleration vector of the requested index.
//! Return false if do not exist enough data for StatDelAcc vector calculation.
//! \param index index of the requested static + delta + acceleration vector
//! \param statDelAccVec pointer to the array where to store the requested static + delta + acceleration vector. Note that memory allocation in statDelAccVec should be assure by the function caller.
template <> bool
FeatureBuffer::getStatDelAccVector(long index, float* statDelAccVec)
{
    if(!isIndexValid(index + halfDelSpan + halfAccSpan)) {//exists enough data for StatDelAcc vector calculation?
		return false ;
    }
    float* statVec = vec(index) ;	//get pointer to index values
    for(int i=0 ; i<vecDimen ; i++)
	 	statDelAccVec[i] = statVec[i] ;//save static values to new vector 
    timeFirFilter(index, statDelAccVec + vecDimen, htkDelFilter, halfDelSpan) ;//get StatDel vector from static values
    timeFirFilter(index, statDelAccVec + 2*vecDimen, htkAccFilter, halfDelSpan + halfAccSpan) ;//get StatDelAccVector from static and delta values
    return true ;
}
template <> bool
FeatureBuffer::getStatDelAccVectorFlush(long index, float* statDelAccVec)
{
    if(!isIndexValid(index)) {//exists enough data for StatDelAcc vector calculation?
		return false ;
    }
    float* statVec = vec(index) ;	//get pointer to index values
    for(int i=0 ; i<vecDimen ; i++)
	 	statDelAccVec[i] = statVec[i] ;//save static values to new vector 
    timeFirFilter(index, statDelAccVec + vecDimen, htkDelFilter, halfDelSpan) ;//get StatDel vector from static values
    timeFirFilter(index, statDelAccVec + 2*vecDimen, htkAccFilter, halfDelSpan + halfAccSpan) ;//get StatDelAccVector from static and delta values
    return true ;
}
//------------------------ DELTA + ACCELERATION -------------------------------//
template <> bool
FeatureBuffer::getDelAccVector(long index, float* statDelAccVec)
{
    if(!isIndexValid(index + halfDelSpan + halfAccSpan)) {//exists enough data for StatDelAcc vector calculation?
		return false ;
    }

    timeFirFilter(index, statDelAccVec , htkDelFilter, halfDelSpan) ;//get StatDel vector from static values
    timeFirFilter(index, statDelAccVec + vecDimen, htkAccFilter, halfDelSpan + halfAccSpan) ;//get StatDelAccVector from static and delta values
    return true ;
}

template <> bool
FeatureBuffer::getDelVectorFlush(long index, float* statDelAccVec)
{
    if(!isIndexValid(index)) {//exists enough data for StatDelAcc vector calculation?
		return false ;
    }

    timeFirFilter(index, statDelAccVec , htkDelFilter, halfDelSpan) ;//get StatDel vector from static values
    //timeFirFilter(index, statDelAccVec + vecDimen, htkAccFilter, halfDelSpan + halfAccSpan) ;//get StatDelAccVector from static and delta values
    return true ;
}



template <> bool
FeatureBuffer::getDelAccVectorFlush(long index, float* statDelAccVec)
{
    if(!isIndexValid(index)) {//exists enough data for StatDelAcc vector calculation?
		return false ;
    }

    timeFirFilter(index, statDelAccVec , htkDelFilter, halfDelSpan) ;//get StatDel vector from static values
    timeFirFilter(index, statDelAccVec + vecDimen, htkAccFilter, halfDelSpan + halfAccSpan) ;//get StatDelAccVector from static and delta values
    return true ;
}
//------------------------ STATIC + SHIFT DELTA  -------------------------------//
template <> bool
FeatureBuffer::getStatShiftDelVector(long index,float* filOut,int P,int D,int K)
{
	if(!isIndexValid(index + (K-1)*P-D )) {//exists enough data for StatDelAcc vector calculation?
		// cout << "Not enough frames in buffer for delta & acc" << endl ;
		return false ;
    }

	float* statVec = vec(index) ;	//get pointer to index values
  for(int i=0 ; i<vecDimen ; i++)
		filOut[i] = statVec[i] ;//save static values to new vector 
	
	ShiftDeltaFilter(index,filOut + vecDimen,P,D,K);
/*
	if(index<=4){
		for(int i=0 ; i<(K+1)*vecDimen ; i++){
				//cout << filOut[i] << " " ;	

		}
		cout << " " << endl;
	}*/
	return true;

}

template <> bool
FeatureBuffer::getStatShiftDelVectorFlush(long index,float* filOut,int P,int D,int K)
{
	if(!isIndexValid(index )) {//exists enough data for StatDelAcc vector calculation?
		// cout << "Not enough frames in buffer for delta & acc" << endl ;
		return false ;
    }

	float* statVec = vec(index) ;	//get pointer to index values
  for(int i=0 ; i<vecDimen ; i++)
		filOut[i] = statVec[i] ;//save static values to new vector 

	ShiftDeltaFilter(index,filOut + vecDimen,P,D,K);
	return true;

}





//------------------------ SHIFT DELTA  -------------------------------//
//El flush no te sentit quan processem tot el fitxer al final!!
//nomes te sentit quan es fa pas a pas...
template <> bool
FeatureBuffer::getShiftDelVector(long index,float* filOut,int P,int D,int K)
{
	if(!isIndexValid(index + (K-1)*P-D )) {//exists enough data for StatDelAcc vector calculation?
		// cout << "Not enough frames in buffer for delta & acc" << endl ;
		return false ;
    }

	ShiftDeltaFilter(index,filOut,P,D,K);
	return true;

}


template <> bool
FeatureBuffer::getShiftDelVectorFlush(long index,float* filOut,int P,int D,int K)
{
	if(!isIndexValid(index)) {//exists enough data for StatDelAcc vector calculation?
		// cout << "Not enough frames in buffer for delta & acc" << endl ;
		return false ;
    }

	ShiftDeltaFilter(index,filOut,P,D,K);
	return true;
}


//Just offline implemented
/*template <> bool
FeatureBuffer::getFeatureWarpedVector(long index,float* filOut,int P,int D,int K)
{
	if(!isIndexValid(index)) {//exists enough data for StatDelAcc vector calculation?
		// cout << "Not enough frames in buffer for delta & acc" << endl ;
		return false ;
    }

	FeatureWarper(index,filOut,P,D,K);
	return true;

}*/




















template <> bool
FeatureBuffer::getAllFeatures(long index, float* inVec)
{
		//isIndexValid returns ture if index < last 
		//we want to know whether index=last to stop reading, so, we need to compare index+1
		
    if(isIndexValid(index)) {//exists unread feature 
			float* statVec = vec(index) ;	//get pointer to index values
    	for(int i=0 ; i<vecDimen ; i++)
				inVec[i] = statVec[i] ;
			return true ;
    }else{
			return false ; //all features have been read
		}
}


template <> bool
FeatureBuffer::getSomeFeatures(long index, float* inVec,int initf,int endf)
{
		//isIndexValid returns ture if index < last 
		//we want to know whether index=last to stop reading, so, we need to compare index+1
	
    if(isIndexValid(index)) {//exists unread feature 
			float* statVec = vec(index) ;	//get pointer to index values
			int max=endf-initf;
    	for(int i=0 ; i< max ; i++)
			//cout << i << endl;
				inVec[i] = statVec[initf+i] ;
			return true ;
    }else{
			return false ; //all features have been read
		}
}


template <> bool
FeatureBuffer::getSCFeatures(long index, float* inVal)
{
		//isIndexValid returns ture if index < last 
		//we want to know whether index=last to stop reading, so, we need to compare index+1
		if(!isIndexValid(index)) {
				return false ;
    }
    
		float* scVec;
		scVec = new float[12];//nomes 13 coefficents
		float tmp=0;
		
		SCFilter(index, scVec  , htkDelFilter, halfDelSpan) ;//get StatDel vector from static values
    //timeFirFilter(index, statDelAccVec + 2*vecDimen, htkAccFilter, halfDelSpan + halfAccSpan) ;//get StatDelAccVector from static and delta values
		//for(int i=0 ; i<40 ; i++){
			//std::cout << scVec[i] << " ";
		//}
		for(int i=0 ; i<12 ; i++){
			tmp=scVec[i]*scVec[i];
		}
		delete [] scVec;
		tmp=tmp/(2*halfDelSpan+1);
//for(i=1 ; i<=halfDelSpan ; i++)			//normalization factor calculation
	//		normFactor += i * i 
		(*inVal)=tmp;
				
    
		return true ;
}




//Provides the time differences between the sub-band log energy of the requested index vector and the previous one
//! By default the number of sub-bands is 4, and subBLEpos=20 is the position where the vector in the buffer contains the first sub-band log value.
//! \param index index of the vector where sub-band log engergies are
//! \param vecOut pointer to the array where to store the requested sub-band log energy time differences. Note that memory allocation in statDelAccVec should be assure by the function caller.

template <> void
FeatureBuffer::subBandLogEnergyTimeDifferences(long index, float* vecOut)
{
    long idxPrio, idx=index;
    int i,subBLEpos;
    
    subBLEpos=20; //aquesta es la posicio inical deles subLE al nostre vector	this is the position in the oup
    if(isCirQ()) idx &=(cirQSize-1) ;	//modulus indexation needed if is circular

    idxPrio=index-1;
    if(idxPrio<0) idxPrio=0 ;
    if(isCirQ()) idxPrio &= (cirQSize-1) ;


    for(i=0;i<4;i++)	//4 Sub bands
    {
		//printf("%f-%f ",(*this)[idx*vecDimen+subBLEpos+i],(*this)[idxPrio*vecDimen+subBLEpos+i]);
    	vecOut[i]=(*this)[idx*vecDimen+subBLEpos+i]-(*this)[idxPrio*vecDimen+subBLEpos+i];
		//printf("vec:%f",vecOut[i]);
 	 } 
}



//Calculates and provides non-perceptual features + delta + acceleration + perceptual + SBLETD from the non-perceptual+perceptual vector of the requested index.
//! Return false if do not exist enough data for StatDelAcc vector calculation.  By default the number of non-perceptual features is set to 16 and the number of perceptual features is set to 8.
//! \param index index of the requested static + delta + acceleration vector
//! \param statDelAccVec pointer to the array where to store the requested static + delta + acceleration vector. Note that memory allocation in statDelAccVec should be assure by the function caller.
template <> bool
FeatureBuffer::getStat2DelAccVector(long index, float* featStatisticsVec)
{
    //index points to the vector of interest    
    //we need to know if we have at least two frames, to calculate subBandLogEnergyTimeDif
    if(!isIndexValid(index+halfDelSpan+halfAccSpan)){
    	//cout <<"Not enoguh frames in buffer for subBandLogEnergy" << endl ;
		//printf("%f",featStatisticsVec[0]);
		return false;	
    }

    float* featVec = vec(index) ;

    int firstPerceptualIdx=16;
    int numPerceptualFeat=8;
    float* auxFeatVec=(float *)malloc(numPerceptualFeat*sizeof(float));
    
    int i;
    for( i=0 ; i<firstPerceptualIdx ; i++)//save first non-perceptual vector values
	 {	
			featStatisticsVec[i] = featVec[i] ;
			
	 }
    //i=firstPerceptualIdx;
    int j;
    for( j=0 ;j<numPerceptualFeat; j++) //save perceptual vector values to auxiliar vector
	 {
			auxFeatVec[j] = featVec[i+j] ;
  			//printf("a:%f",auxFeatVec[j]);
	 }

    timeFirFilter(index, featStatisticsVec+ 16, htkDelFilter, halfDelSpan) ;//get StatDel vector from non-perceptual values
    timeFirFilter(index, featStatisticsVec + 2*16, htkAccFilter, halfDelSpan + halfAccSpan) ;//get StatDelAcc vector from non-perceptual values
    for(j=0,i=(3*16); j<numPerceptualFeat; j++,i++)//add perceptual values at the end of the vector
    {		
			featStatisticsVec[i] = auxFeatVec[j] ;
	}
	 //i=3*16+8;
    subBandLogEnergyTimeDifferences(index, featStatisticsVec+i) ; //calculate the subBandLogEnergy of 

	 free(auxFeatVec);
    return true ;

}

template <> bool
FeatureBuffer::getStat2DelAccFlush(long index, float* featStatisticsVec)
{
  
  if(!isIndexValid(index)){
			return false;	
    }

 float* featVec = vec(index) ;
    
    int firstPerceptualIdx=16;
    int numPerceptualFeat=8;
    float* auxFeatVec=(float *)malloc(numPerceptualFeat*sizeof(float));
    
    int i;

    for( i=0 ; i<firstPerceptualIdx ; i++)
	 {	featStatisticsVec[i] = featVec[i] ; 	}

    int j;
    for( j=0 ;j<numPerceptualFeat; j++) 
	{auxFeatVec[j] = featVec[i+j] ;}

    timeFirFilter(index, featStatisticsVec+ 16, htkDelFilter, halfDelSpan) ;
    timeFirFilter(index, featStatisticsVec + 2*16, htkAccFilter, halfDelSpan + halfAccSpan) ;
    for(j=0,i=(3*16); j<numPerceptualFeat; j++,i++)
   {	featStatisticsVec[i] = auxFeatVec[j] ;}

    subBandLogEnergyTimeDifferences(index, featStatisticsVec+i) ;

free(auxFeatVec);
    return true ;

}


//Saves all features, static only, or static + delta + acceleration.
//! \param fname filename where to save the features
//! \param saveDelAcc save also the delta and acceleration versions? 1=yes, 0=no 
template <> void
FeatureBuffer::saveFeatures(const char* fname, bool saveDelAcc)
{
    long frCounter = 0 ;
    ofstream outputStream (fname) ;
    if (!outputStream) {
	cout << "FeatureBuffer::saveFeatures ERROR: when opening output FE feat file " << fname << endl ;
	exit(0) ;
    }
    float shift_ms = 1000.0 * (1.0 / dataRate) ; // dataRate is in Hz, shift is in ms
    outputStream.write((char*) &shift_ms, sizeof(float)) ;
    if(saveDelAcc) {
	int featSize = 3 * vecDimen ;
	outputStream.write((char*) &featSize, sizeof(int)) ;
	//cout << "Saving " << featSize << " static+der+acc FE feats per frame (incl low- & hi-freq feats if calc) in " << fname << endl ;
	float* features = new float [featSize] ;
	while (getStatDelAccVector(frCounter, features)) {
	    outputStream.write((char*) features, featSize * sizeof(float)) ;
	    frCounter++ ;
	}
	delete [] features ;
    }
    else {
	outputStream.write((char*) &vecDimen, sizeof(int)) ;
	//cout << "Saving " << vecDimen << " static FE feats per frame (incl low- & hi-freq feats if calc) in " << fname << endl ;
	for(frCounter=0 ; frCounter<length() ; frCounter++)
	    outputStream.write((char*) vec(frCounter), vecDimen * sizeof(float)) ;
    }
    outputStream.write((char*) &frCounter, sizeof(long)) ;
    outputStream.close() ;
    cout << frCounter << " frames written." << endl ;
}


void FloatVectorByteSwap(float* vec,int size)
{
	for(int i=0; i < size ; i++){
	
		unsigned char *cptr,tmp;
		cptr = (unsigned char *) &vec[i];
		tmp = cptr[0];
		cptr[0] = cptr[3];
		cptr[3] =tmp;
		tmp = cptr[1];
		cptr[1] = cptr[2];
		cptr[2] = tmp;
	
	}
}
 

template <> void
//FeatureBuffer::saveHTKFeatures(const char* fname, bool saveDelAcc,bool doFeatWarping,string stringtable)
FeatureBuffer::saveHTKFeatures(const char* fname, bool saveDelAcc)
{
  long frCounter = 0 ;
  ofstream outputStream (fname) ;
  if (!outputStream) {
		cout << "FeatureBuffer::saveFeatures ERROR: when opening output FE feat file " << fname << endl ;
		exit(0) ;
  }
	
	//----------------------------------- write Header ---------------------------------//
	//nSamples
	int nSamples = SWAP_4(last) ;
	outputStream.write((char*) &nSamples, sizeof(int)) ;
	//sampPeriod
	int sampPeriod = 10000000 * (1.0 / dataRate) ;  // dataRate is in Hz, shift is in 100ns (HTK format)
	sampPeriod = SWAP_4(sampPeriod);
    outputStream.write((char*) &sampPeriod, sizeof(int)) ;
	//sampSize
	short sampSize ;
	if(saveDelAcc){
		sampSize = 3 * vecDimen * 4 ;//4-byte floating point features
	}else{
		sampSize = vecDimen * 4 ;//4-byte floating point features
	}
	sampSize = SWAP_2(sampSize);
	outputStream.write((char*) &sampSize, sizeof(short)) ;
	//paramKind
	short paramKind = 9;
	paramKind += 004000 ; //dc offset
	if(saveDelAcc){
		paramKind += 0000400 ;//delta
		paramKind += 0001000 ;//acceleration
		//add DC offset
	}
	paramKind = SWAP_2(paramKind);
	outputStream.write((char*) &paramKind, sizeof(short)) ;
	//------------------------------------------------------------------------------------//
	int featSize;
  if(saveDelAcc) {
		featSize = 3 * vecDimen ;
	}else{
		featSize =  vecDimen ;
	}

	float* features = new float [featSize] ;
	//bool doFeatWarping=false;
	bool doFeatWarping=false; 
	string stringtable;
	if(doFeatWarping){
		//first get temproal-filtered features
		//wrtie 
		FeatWarper Fw(301);
		Fw.setInput(this);
		Fw.doWarping(stringtable);
		if(saveDelAcc){
			while (getDelAccVector(frCounter, features+vecDimen )) {
				//write first static!!
				

				Fw.getWarpedVector(frCounter,features);
				//cout << features[0] << endl;
				/*if(frCounter==112){
					for(int i=0;i<vecDimen;i++){
						cout << features[i] << " " ;
					
					}
				cout << " " << endl;
				}*/
				FloatVectorByteSwap(features,featSize);
				outputStream.write((char*) features, featSize * sizeof(float)) ;				
				frCounter++ ;
			}
			while (getDelAccVectorFlush(frCounter, features+vecDimen )) {
			Fw.getWarpedVector(frCounter,features);
				FloatVectorByteSwap(features,featSize);
				outputStream.write((char*) features, featSize * sizeof(float)) ;				
				frCounter++ ;
			}	
		}else{//static warped?


		}
		//then, get static warped features
	}else{
		if(saveDelAcc){
			while (getStatDelAccVector(frCounter, features)) {
				//cout << features[0] << endl;
				
				
				
				FloatVectorByteSwap(features,featSize);
				outputStream.write((char*) features, featSize * sizeof(float)) ;				
				frCounter++ ;
			}
			while (getStatDelAccVectorFlush(frCounter, features)) {
				FloatVectorByteSwap(features,featSize);
				outputStream.write((char*) features, featSize * sizeof(float)) ;				
				frCounter++ ;
			}	
			//cout << "Saving " << featSize << " static+der+acc FE feats per frame  in " << fname << endl ;
		}else{
			//cout << "Saving " << vecDimen << " static FE feats per frame (incl low- & hi-freq feats if calc) in " << fname << endl ;
			
			for(frCounter=0 ; frCounter<length() ; frCounter++){
				float* f=vec(frCounter);
				for(int i=0;i<featSize;i++){
					features[i]=f[i];
				}
				FloatVectorByteSwap(features,featSize);
				outputStream.write((char*) features, featSize * sizeof(float)) ;
				}
		}
	}
	
	delete [] features ;

  outputStream.close() ;

}


template <> void
FeatureBuffer::saveSelFFtoHTK(const char* fname, bool saveDelAcc)
{
	long frCounter = 0 ;
	ofstream outputStream (fname) ;
	if (!outputStream) {
		cout << "FeatureBuffer::saveFeatures ERROR: when opening output FE feat file " << fname << endl ;
		exit(0) ;
	}
	
	//----------------------------------- write Header ---------------------------------//
	//nSamples
	int nSamples = SWAP_4(last) ;
	outputStream.write((char*) &nSamples, sizeof(int)) ;
	//sampPeriod
	int sampPeriod = 10000000 * (1.0 / dataRate) ;  // dataRate is in Hz, shift is in 100ns (HTK format)
	sampPeriod = SWAP_4(sampPeriod);
  outputStream.write((char*) &sampPeriod, sizeof(int)) ;
	//sampSize
	short sampSize ;
	//int selVecDimen=vecDimen-2;

	
	if(saveDelAcc){
	sampSize = 3 * vecDimen * 4 ;//4-byte floating point features
	
	}else{
	sampSize = vecDimen * 4 ;//4-byte floating point features
	
	}
	sampSize = SWAP_2(sampSize);
	outputStream.write((char*) &sampSize, sizeof(short)) ;
	//paramKind
	short paramKind = 9;

	paramKind = SWAP_2(paramKind);
	outputStream.write((char*) &paramKind, sizeof(short)) ;
	//------------------------------------------------------------------------------------//
	int featSize;
	
  if(saveDelAcc) {
		featSize = 3 * vecDimen ;
		
	}else{
		featSize =  vecDimen ;
	
	}

	float* features = new float [featSize] ;

	
	if(saveDelAcc){
		while (getStatDelAccVector(frCounter, features)) {
			//cout << features[0] << endl;
			
// 			for(int i=0;i<selVecDimen;i++){
// 				selected[i]=features[i+1];
// 				selected[selVecDimen+i]=features[vecDimen+i+1];
// 				selected[2*selVecDimen+i]=features[2*vecDimen+i+1];
// 			}
			
			
			FloatVectorByteSwap(features,featSize);
			outputStream.write((char*) features, featSize * sizeof(float)) ;				
			//FloatVectorByteSwap(selected,selFeatSize);
			//outputStream.write((char*) selected, selFeatSize * sizeof(float)) ;				
			
			frCounter++ ;
		}
		while (getStatDelAccVectorFlush(frCounter, features)) {
// 			for(int i=0;i<selVecDimen;i++){
// 				selected[i]=features[i+1];
// 				selected[selVecDimen+i]=features[vecDimen+i+1];
// 				selected[2*selVecDimen+i]=features[2*vecDimen+i+1];
// 			}
			
			//FloatVectorByteSwap(selected,selFeatSize);
				FloatVectorByteSwap(features,featSize);
			//outputStream.write((char*) selected, selFeatSize * sizeof(float)) ;		
			outputStream.write((char*) features, featSize * sizeof(float)) ;			
			frCounter++ ;
		}	
		//cout << "Saving " << featSize << " static+der+acc FE feats per frame  in " << fname << endl ;
	}else{
		//cout << "Saving " << vecDimen << " static FE feats per frame (incl low- & hi-freq feats if calc) in " << fname << endl ;
		
		for(frCounter=0 ; frCounter<length() ; frCounter++){
			float* f=vec(frCounter);
			for(int i=0;i<featSize;i++){
				features[i]=f[i];
			}
			FloatVectorByteSwap(features,featSize);
			outputStream.write((char*) features, featSize * sizeof(float)) ;
			}
	}
		
		
	
	
	delete [] features ;

  outputStream.close() ;

}



template <> void
FeatureBuffer::saveHTK_SDC_Features(const char* fname,bool saveShiftDel,int D,int P,int K)
{

	//int D=1;
	//int K=7;
	//int P=3;
  long frCounter = 0 ;
  ofstream outputStream (fname) ;
  if (!outputStream) {
		cout << "FeatureBuffer::saveFeatures ERROR: when opening output FE feat file " << fname << endl ;
		exit(0) ;
  }
	
	//----------------------------------- write Header ---------------------------------//
	//nSamples
	int nSamples = SWAP_4(last) ;
	outputStream.write((char*) &nSamples, sizeof(int)) ;
	//sampPeriod
	int sampPeriod = 10000000 * (1.0 / dataRate) ; // dataRate is in Hz, shift is in 100ns (HTK format)
	sampPeriod = SWAP_4(sampPeriod);
  outputStream.write((char*) &sampPeriod, sizeof(int)) ;
	//sampSize
	int featSize;
	if(saveShiftDel){
		featSize = (K+1) * vecDimen ;
	}else{
		featSize = vecDimen ;
	}
	float* features = new float [featSize] ;
	short sampSize = featSize * 4 ;//4-byte floating point features
	sampSize = SWAP_2(sampSize);
	outputStream.write((char*) &sampSize, sizeof(short)) ;
	//paramKind
	short paramKind = 9;
	paramKind += 004000 ; //dc offset
	//no posem res mes pq el numero de deltes no es el mateix que el de statics!
	paramKind = SWAP_2(paramKind);
	outputStream.write((char*) &paramKind, sizeof(short)) ;
	//------------------------------------------------------------------------------------//	
	if(saveShiftDel){
		while (getStatShiftDelVector(frCounter, features,P,D,K )) { 
			//cout << "notfl" << endl;
	/*if(frCounter<=4){
	for(int i=0 ; i<(K+1)*vecDimen ; i++){
			cout << features[i] << " " ;	

	}
	cout << " " << endl;
}*/
	//cout << (K+1)*vecDimen << " " << featSize << endl;
		FloatVectorByteSwap(features,featSize);
		outputStream.write((char*) features, featSize * sizeof(float)) ;
		frCounter++ ;
	


		}
		while(getStatShiftDelVectorFlush(frCounter, features,P,D,K )) { 
		//cout << "fl" << endl;
			FloatVectorByteSwap(features,featSize);
			outputStream.write((char*) features, featSize * sizeof(float)) ;
			frCounter++ ;
		}
	}else{

	//cout << "Saving " << vecDimen << " static FE feats per frame (incl low- & hi-freq feats if calc) in " << fname << endl ;
		for(frCounter=0 ; frCounter<length() ; frCounter++)
			outputStream.write((char*) vec(frCounter), vecDimen * sizeof(float)) ;
	}

	
	

}



template <> void
FeatureBuffer::saveEnergy(const char* fname, bool saveDelAcc,bool doFeatWarping,string stringtable)
{
    long frCounter = 0 ;
    ofstream outputStream (fname) ;
    if (!outputStream) {
	cout << "FeatureBuffer::saveFeatures ERROR: when opening output FE feat file " << fname << endl ;
	exit(0) ;
    }
	//cout << "dataRate" << dataRate << endl;
	
	//----------------------------------- write Header ---------------------------------//
		//nSamples
	int nSamples = SWAP_4(last) ;
	outputStream.write((char*) &nSamples, sizeof(int)) ;
	//sampPeriod
	int sampPeriod = 10000000 * (1.0 / dataRate) ;  // dataRate is in Hz, shift is in 100ns (HTK format)
	sampPeriod = SWAP_4(sampPeriod);
    outputStream.write((char*) &sampPeriod, sizeof(int)) ;
	//sampSize
	short sampSize ;

	sampSize = 1 * 4 ;//4-byte floating point features
	
	sampSize = SWAP_2(sampSize);
	outputStream.write((char*) &sampSize, sizeof(short)) ;
	//paramKind
	short paramKind = 9;
	paramKind += 004000 ; //dc offset
	
	paramKind = SWAP_2(paramKind);
	outputStream.write((char*) &paramKind, sizeof(short)) ;
	//------------------------------------------------------------------------------------//
	int featSize;
 
		featSize =  vecDimen ;
	

	float* features = new float [featSize] ;
	//bool doFeatWarping=false;

	
for(frCounter=0 ; frCounter<length() ; frCounter++){
				float* f=vec(frCounter);
				for(int i=0;i<featSize;i++){
					features[i]=f[i];
				//	cout << features[i] << " " ;
			}
	//cout <<  " " << endl;
	//cout << features[12] << endl;	
	FloatVectorByteSwap(features,featSize);
	
	outputStream.write((char*) features, 1 * sizeof(float)) ;
		}

	delete [] features ;

  outputStream.close() ;

}














//Saves selected features, static only, or static + delta + acceleration.
//! \param fname filename where to save the features
//! \param saveDelAcc save also the delta and acceleration versions? 1=yes, 0=no
//! \param selFeatIdx selected feature indices
//! \param selFeatSize selected feature vector size
template <> void
FeatureBuffer::saveFeatures(const char* fname, bool saveDelAcc, int* selFeatIdx, int selFeatSize) 
{
    // do not care about saveDelAcc, always save depending on selFeatIdx and selFeatSize
    int i ;
    long frCounter = 0 ;
    float* features ;
    ofstream outputStream (fname) ;
    if (!outputStream) {
	cout << "FeatureBuffer::saveFeatures ERROR: when opening output FE feat file " << fname << endl ;
	exit(0) ;
    }
    float shift_ms = 1000.0 * (1.0 / dataRate) ; // dataRate is in Hz, shift is in ms
    outputStream.write((char*) &shift_ms, sizeof(float)) ;
    outputStream.write((char*) &selFeatSize, sizeof(int)) ;
    features = new float [3*vecDimen] ;
    cout << "Saving " << selFeatSize << " selected FE feats per frame in " << fname << endl ;
    while (getStatDelAccVector(frCounter, features)) {
	for(i=0 ; i<selFeatSize ; i++) features[i] = features[selFeatIdx[i]] ;
	outputStream.write((char*) features, selFeatSize * sizeof(float)) ;
	frCounter++ ;
    }
    outputStream.write((char*) &frCounter, sizeof(long)) ;
    delete [] features ;
    outputStream.close() ;
    cout << frCounter << " frames written." << endl ;
}
// FeatureBuffer --- end ---

// SadFlagBuffer --- start ---

/*//Save SAD output flag to a file in XML format.
//! \param fname filename where to save the SAD output
template <> void
SadFlagBuffer::saveXmlSad(const char* fname) 
{
    long frCounter = 0 ;
    sadBins outForXml ;

    outForXml.sampFreq = 100.0 ;  // frames per sec
    outForXml.binsSize = length() ;
    outForXml.bins     = new int [outForXml.binsSize] ;
    outForXml.aStart   = 0.0 ;
    outForXml.dStart   = 0.0 ;
    outForXml.aEnd     = outForXml.binsSize / outForXml.sampFreq ;
    outForXml.dEnd     = outForXml.aEnd ;

    for (frCounter=0 ; frCounter < outForXml.binsSize ; frCounter++) {
	if(*(vec(frCounter)) == 's')
	    outForXml.bins [frCounter] = 1 ;  // speech
	else
	    outForXml.bins [frCounter] = 0 ;  // non-speech ; 'n' is assumed here
    }	   

    cout << "Saving SAD XML output into " << fname << endl;

    // write SadXml file  
    writeXMLFromSadBins (fname, &outForXml);

    delete [] outForXml.bins ;
}*/

/*
void
writeRttmFromSadBins (const char *fname, sadBins *sBinsPtr)
{
    float startTime , endTime ;
    FILE *f ;
    char fileID [256] ;
    char *charPtr ;

    if((f = fopen(fname, "w")) == NULL) {
        printf("writeRttmFromSadBins ERROR: when opening output RTTM SAD file %s\n", fname) ;
        exit(0) ;
    }
	
    //strcpy(fileID, strrchr(fname, '/') + 1) ;
    char temp1[256];
    char temp2[256];
    strcpy(temp1, strchr(fname, '/') + 1) ; //attention!! I change this only for scooring sad correctly
    strcpy(temp2, strchr(temp1, '/') + 1) ; //attention!! I change this only for scooring sad correctly
    strcpy(fileID, strchr(temp2, '/') + 1) ; //attention!! I change this only for scooring sad correctly
    charPtr = strchr(fileID, '.') ;
    *charPtr = '\0' ;
    fprintf (f, "SPKR-INFO %s 1 <NA> <NA> <NA> unknown speech <NA>\n", fileID) ;
    //fprintf (f, "SPKR-INFO %s 1 <NA> <NA> <NA> unknown speech <NA>\n", fname) ;
    for(long i=0 ; i<sBinsPtr->binsSize ; i++) {
	if(sBinsPtr->bins[i] == 1) {
	    startTime = (float) ((float) i / (float) sBinsPtr->sampFreq) + sBinsPtr->dStart ;
	    while (((++i)<sBinsPtr->binsSize) && (sBinsPtr->bins[i] == 1)) ;
	    endTime = (float) ((float) i / (float) sBinsPtr->sampFreq) + sBinsPtr->dStart ;
	    fprintf (f, "SPEAKER %s 1 %1.3f %1.3f <NA> <NA> speech <NA>\n", fileID, startTime, endTime-startTime) ;
	}
    }
    fclose(f) ;
}*/
/*
//Save SAD output flag to a file in RTTM format.
//! \param fname filename where to save the SAD output
template <> void
SadFlagBuffer::saveRttmSad(const char* fname) 
{
    long frCounter = 0 ;
    sadBins outForXml ;

    outForXml.sampFreq = 100.0 ;  // frames per sec
    outForXml.binsSize = length() ;
    outForXml.bins     = new int [outForXml.binsSize] ;
    outForXml.aStart   = 0.0 ;
    outForXml.dStart   = 0.0 ;
    outForXml.aEnd     = outForXml.binsSize / outForXml.sampFreq ;
    outForXml.dEnd     = outForXml.aEnd ;

    for (frCounter=0 ; frCounter < outForXml.binsSize ; frCounter++) {
	if(*(vec(frCounter)) == 's')
	    outForXml.bins [frCounter] = 1 ;  // speech
	else
	    outForXml.bins [frCounter] = 0 ;  // non-speech ; 'n' is assumed here
    }	   
    cout << "Saving SAD RTTM output into " << fname << endl;
    // write SadRttm file  
    writeRttmFromSadBins (fname, &outForXml);
    delete [] outForXml.bins ;
}*/

/*//Save SAD output flag to a file in bins format.
//! \param fname filename where to save the SAD output
template <> void
SadFlagBuffer::saveBinsSad(const char* fname) 
{
    long frCounter = 0 ;
    sadBins outForXml ;
    FILE *f ;

    outForXml.sampFreq = 100.0 ;  // frames per sec
    outForXml.binsSize = length() ;
    outForXml.bins     = new int [outForXml.binsSize] ;
    outForXml.aStart   = 0.0 ;
    outForXml.dStart   = 0.0 ;
    outForXml.aEnd     = outForXml.binsSize / outForXml.sampFreq ;
    outForXml.dEnd     = outForXml.aEnd ;
    for (frCounter=0 ; frCounter < outForXml.binsSize ; frCounter++) {
	if(*(vec(frCounter)) == 's')
	    outForXml.bins [frCounter] = 1 ;  // speech
	else
	    outForXml.bins [frCounter] = 0 ;  // non-speech ; 'n' is assumed here
    }
    // write Sad flag bins file 
    cout << "Saving SAD Bins output into " << fname << endl;
    if((f = fopen(fname, "w")) == NULL) {
        printf("SadFlagBuffer::saveFlagBinsSad ERROR: when opening output flag bins SAD file %s\n", fname) ;
        exit(0) ;
    }
    fprintf(f, "%% The final line without %% contains the following SAD info:\n") ;
    fprintf(f, "%% flag_shift_in_ms flag[1] flag[2] flag[3] ...\n") ;
    fprintf(f, "%2.2f ", (float) (1000.0/outForXml.sampFreq)) ;
    for(frCounter=0 ; frCounter < outForXml.binsSize ; frCounter++)
	fprintf(f, "%i ", outForXml.bins[frCounter]) ;
    fprintf(f, "\n") ;
    fclose(f) ;
    delete [] outForXml.bins ;
}*/

// SadFlagBuffer --- end ---
